//
//  テスト用サンプルプログラム WIRE, I2C スレーブ LCD
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    スレーブ受信したデータをLCDへ表示、スレーブ送信する
//
//    10/05/05,12/02/25
//

#include <LiquidCrystal.h>
#include <Wire.h>
#include <stdio.h>

#define LCD_RS 10         // D10
#define LCD_E 11           // D11
#define LCD_D4 6        // D6
#define LCD_D5 7        // D7
#define LCD_D6 8        // D8
#define LCD_D7 9        // D9

int I2CAdrs;
byte Buf[10];
char StrBuf[16];

// LCDのインスタンス化
LiquidCrystal lcd(LCD_RS,  LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7);

//LiquidCrystal lcd(10, 11, 6, 7, 8, 9);
//LiquidCrystal(rs, enable, d4, d5, d6, d7)

// 初期化
void setup(void) {
  pinMode(13, OUTPUT);        // オンボードLED

  lcd.begin(16,2);    // LCDを16文字2行に設定

  I2CAdrs = 0x10;
  Wire.begin(I2CAdrs);        // スレーブ初期化
  Wire.onReceive(hI2CSlvRcv);
  Wire.onRequest(hI2CSlvSnd);


 lcd.print("I2C Test");

}


// メインループ
void loop(void) {
}


// スレーブ受信時のハンドラ
void hI2CSlvRcv(int cnt) {
  byte i;

  for(i = 0; i < cnt; i++) {
    Buf[i] = Wire.read();               // データ スレーブ受信
//  Buf[i] =  Wire.receive(Buf[i]);     // データ スレーブ受信(旧バージョン)

  }

  // LCDに2バイトの文字列を表示
  sprintf(StrBuf, "%02X,%02X", Buf[0], Buf[1]);
  lcd.setCursor(0, 1);                // LCDカーソル位置指定
  lcd.print(StrBuf);

  digitalWrite(13, HIGH);   // LED ON
}


// スレーブ送信時のハンドラ
void hI2CSlvSnd(void) {
  Wire.write(Buf, 2);       // データ スレーブ送信送信
//Wire.send(Buf, 2);        // データ スレーブ送信送信(旧バージョン)

  digitalWrite(13, LOW);    // LED OFF
}
