//
//  テスト用サンプルプログラム WIRE, I2C-EEPROM serial
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    EEPROMに2バイト書き込んですぐに読み出し、結果をシリアル送信
//
//    10/05/05, 12/2/26
//


#include <Wire.h>
//#include <stdio.h>

int EprAdrs;            // EEPROMのI2Cスレーブアドレス

byte RomDat[2];         // EEPROM書き込みデータ
byte RomDat2[2];        // EEPROM読み出しデータ
unsigned int RomAdrs;   // EEPROMアドレス
char StrBuf[16];


// 初期化/メイン処理
void setup(void) {
  byte i;

  Serial.begin(19200);    // シリアル通信初期化

  Wire.begin();       // マスタ初期化

  EprAdrs = 0x50;     // EEPROMのI2Cスレーブアドレス

  RomAdrs = 0x0010;   // EEPROMアドレス
  RomDat[0] = 0x12;   // EEPROMデータ1
  RomDat[1] = 0x34;   // EEPROMデータ2

  // ---------- EEPROM 2バイト書き込み ------------
  Wire.beginTransmission(EprAdrs);  // S.C発行,CB送信
  Wire.write((byte)(RomAdrs>>8));    // EEPROM上位アドレス
  Wire.write((byte)RomAdrs);         // EEPROM下位アドレス

  for(i = 0; i < 2; i++) {
    Wire.write(RomDat[i]);           // データ書き込み
  }

  Wire.endTransmission();           // ストップ・コンディション

  delay(5);                     // 書き込み完了待ち(5ms以上必要)

  // ----------- EEPROM 2バイト読み出し -----------------
  Wire.beginTransmission(EprAdrs);  // S.C発行,CB送信
  Wire.write((byte)(RomAdrs>>8));    // EEPROM上位アドレス
  Wire.write((byte)RomAdrs);         // EEPROM下位アドレス
  Wire.endTransmission();           // ストップ・コンディション
  // いったん終了

  // EEPROMデータ受信
  Wire.requestFrom(EprAdrs, 2);    // S.C発行,CB送信

  for(i = 0; i < 2; i++) {          // EEPROMデータの読み出し
    RomDat2[i] = Wire.read();
  }

  // ------------ シリアル送信 -----------------
  sprintf(StrBuf, "%02X %02X", RomDat2[0], RomDat2[1]);
  Serial.println(StrBuf);       // 文字を出力
}


// メインループ
void loop(void) {
}
