//
//  テスト用サンプルプログラム WIRE, I2C マスタ
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    マスタ送信してマスタ受信する
//
//    10/05/05,12/02/25
//

#include <Wire.h>

int I2CAdrs;
byte Buf[10];


// 初期化
void setup(void) {
  pinMode(13, OUTPUT);        // オンボードLED
  I2CAdrs = 0x10;

  Buf[0] = 0x34;
  Buf[1] = 0x56;

  Wire.begin();       // マスタ初期化
}


// メインループ
void loop(void) {
  byte i;

  // マスタ送信
  Wire.beginTransmission(I2CAdrs);  // S.C発行,CB送信

  for(i = 0; i < 2; i++) {
    Wire.write(Buf[i]);             // データ書き込み
//    Wire.send(Buf[i]);            // データ書き込み(旧バージョン)
  }

  Wire.endTransmission();           // ストップ・コンディション

  digitalWrite(13, HIGH);   // LED ON
  delay(1000);

  // マスタ受信
  Wire.requestFrom(I2CAdrs, 2);     // S.C発行,CB送信

  for(i = 0; i < 2; i++) {
    Buf[i] = Wire.read();           // データの読み出し
//  Buf[i] = Wire.receive();        // データの読み出し(旧バージョン)
  }

  digitalWrite(13, LOW);    // LED OFF
  delay(1000);
}
