//
//  テスト用サンプルプログラム WIRE, I2C マスタ
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    マスタ送信してマスタ受信する
//
//    10/05/05
//    10/05/08 シリアル通信機能追加
//

#include <Wire.h>

int I2CAdrs;
byte Buf[10];
char StrBuf[16];

// 初期化
void setup(void) {
  Serial.begin(19200);    // シリアル通信初期化
  I2CAdrs = 0x10;
  Wire.begin();           // マスタ初期化
}

// メインループ
void loop(void) {
  byte i, dat;

  // シリアル・コマンドの受信処理
  if(Serial.available() > 0) {
    // 受信あり
    dat = Serial.read();    // 受信文字の取り出し
    switch(dat) {
      case '1':         // マスタ送信
        Buf[0] = 0x11;
        Buf[1] = 0x11;
        I2cSendData();
        break;
      case '2':         // マスタ送信
        Buf[0] = 0x22;
        Buf[1] = 0x22;
        I2cSendData();
        break;
      case '3':         // マスタ送信
        Buf[0] = 0x33;
        Buf[1] = 0x33;
        I2cSendData();
        break;
      case '4':         // マスタ送信
        Buf[0] = 0x44;
        Buf[1] = 0x44;
        I2cSendData();
        break;
      case '0':         // マスタ受信
        Wire.requestFrom(I2CAdrs, 2);     // S.C発行,CB送信
        Buf[i] = Wire.read();           // データの読み出し
        sprintf(StrBuf, "%02X %02X", Buf[0], Buf[1]);
        Serial.println(StrBuf);       // 文字を出力
        break;
      default:
        Serial.println("?");             // エラー表示
        break;
    }    // switch文の終わり
  }
}

// I2C 2バイトデータ送信処理
void I2cSendData(void) {
  byte i;

  Wire.beginTransmission(I2CAdrs);    // S.C発行,CB送信
    for(i = 0; i < 2; i++) {
      Wire.write(Buf[i]);             // データ書き込み
    }
    Wire.endTransmission();           // ストップ・コンディション
}
