//
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
#include <LiquidCrystal.h>
#include <stdio.h>

#define LCD_RS 10         // D10
#define LCD_E 11           // D11
#define LCD_D4 6        // D6
#define LCD_D5 7        // D7
#define LCD_D6 8        // D8
#define LCD_D7 9        // D9

// LCDのインスタンス化
LiquidCrystal lcd(LCD_RS, LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7);

char StrBuf[16];    // 文字列用配列
int Count = 0;    // カウント値

// 初期化
void setup(void) {
  lcd.begin(16, 2);    // LCDを16文字2列に設定
}

void loop(void) {
  sprintf(StrBuf, "%04d", Count);
  lcd.setCursor(0, 1);    // 表示位置を指定
  lcd.print(StrBuf);    // LCDに文字列を表示
  Count = (Count + 1) %10000;   // カウント値更新
  delay(1000);    // 1秒待つ
}
