//
//  CANノードB 温度値受信
//
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//

#include <wCan2515.h>
#include <p2515Reg.h>

// CANボードのLED点消灯マクロ
#define CANLED_ON Can.BitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE))
#define CANLED_OFF  Can.BitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), 1<<B0BFE)

wCan2515 Can(2, 4, 3, 5, CAN_BRP_16MHz_125KBPS);  // CANインスタンス
// D2:SCK, D3:SO, D4:SI, D5:SS (SI/SOクロス)

byte CanBuf[14];    // CAN送受信バッファ
int LedPin = 13;    // オンボードLEDのポート番号

// 初期化
void setup(void) {
  pinMode(LedPin, OUTPUT);

  Can.SetMask(MASK_SID_ALL_HIT);
  Can.SetFilter(0);
  Can.SetFilter(0, FILTER_MOD_ALL_HIT); // すべてのメッセージを受信
  Can.SetOpMode(CAM_MODE_NORMAL);

  // SPI送信確認 CANボードのLED点灯
  CANLED_ON;    // LED ON
  delay(500);
  CANLED_OFF;   // LED OFF
  delay(500);
  CANLED_ON;    // LED ON
}

// メインループ
void loop(void) {
  byte size, datfrm;
  unsigned int msg;
  byte dat[8];

  if(Can.RxCheck()) {
    // 受信しているとき
    // データとメッセージを取り出す。
    msg = Can.GetRxBuf(0, dat, &size, &datfrm);

    if(msg == 0x0201) {
      // LED ON
      digitalWrite(LedPin, HIGH);
      Can.SetTxBuf(0, 0x101, dat, 0, true);
      Can.TxReq(0);
    } else if(msg == 0x0200) {
      // LED OFF
      digitalWrite(LedPin, LOW);
      Can.SetTxBuf(0, 0x100, dat, 0, true);
      Can.TxReq(0);
    }
  }

  if(Can.CheckTxComp(0)) {
    // 送信完了チェック
  }
}


