//
//  #297テスト
//    copyright (c) 2012 T.Nakao
//
//    12/06/07 #297 カウンタ表示プログラム
//

#include <wDisplay.h>
#include <wCTimer.h>

// デジタルポートのピン番号定義
int CLK = 2;
int DT = 3;
int COL1 = 4;
int COL2 = 5;
int COL3 = 6;
int COL4 = 7;

wCtcTimer2A tm;                                   // タイマのインスタンス
wD7Seg297 d7s(CLK, DT, COL1, COL2, COL3, COL4);   // 7セグボードのインスタンス

byte Count = 0;
unsigned int d7Count = 0;

// 初期化
void setup(void) {
  tm.init(125);           // タイマ周期を8msに設定

  d7s.onDelay = 500;

//  d7s.setZeroSup(0);      // 0サプレスなし
  d7s.setZeroSup(1);      // 0サプレスあり
}


// メインループ
void loop(void) {
  if(tm.checkTimeup()) {
    // 8ms周期
    Count++;
    if(Count == 125) {
      // 1s周期
      Count = 0;
      d7s.dispBCDVal(d7Count);            // 10進数表示
//      d7s.dispHexaVal(d7Count);            // 16進数表示

      d7Count = (d7Count + 1) % 10000;    // カウント値更新
    }
  }

  d7s.process();
}
