/*
  SDカード ファイル 書き込み
    copyright (c) 2013 T.Nakao      http://www.wsnak.com

    SD card I/F接続
      MOSI (D11)
      MISO (D12)
      CLK (D13)
      CS (D10)
*/

#include <SD.h>       // SDライブラリ

const int chipSelect = 10;    // CSポート番号

File myFile;        // ファイルハンドル

void setup()
{
  Serial.begin(19200);    // シリアル初期化

  Serial.print("\nInitializing SD card...");

  pinMode(chipSelect, OUTPUT);     // SPI CS 出力設定

  if (!SD.begin(chipSelect)) {      // SDオブジェクト初期化
    // 初期化失敗
    Serial.println("initialization failed!");
    return;
  }

  // 初期化成功
  Serial.println("initialization done.");

  // --------- ファイルへ書き込み ---------
  // ファイルを書き込みでオープン
  myFile = SD.open("test.txt", FILE_WRITE);
  if (myFile) {
    // ファイル書き込み
    Serial.print("Writing to test.txt...");
    myFile.println("SD CARD TEST");

    // ファイルクローズ
    myFile.close();
    Serial.println("done.");
  } else {
    // ファイルオープンエラー
    Serial.println("error opening test.txt");
  }

  // -------- ファイルから読み出し ----------
  // ファイルを読み出しでオープンする
  myFile = SD.open("test.txt");
  if (myFile) {
    Serial.println("test.txt:");

    // 無くなるまで読み出しを繰り返す
    while (myFile.available()) {
      // 1行読み出してシリアル送信
      Serial.write(myFile.read());
    }
    // ファイルをクローズ
    myFile.close();
  } else {
    // ファイルオープンエラー
    Serial.println("error opening test.txt");
  }
}


void loop() {

}
