//
//  RTC8564ライブラリ テスト
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    120414 T.Nakao
//    120513
//

#include <Wire.h>
#include <wCTimer.h>

wI2cRtc8564 rtc;    // RTC-8564ドライバ

char StrBuf[16];


//
//  初期化
//
void setup(void) {
  byte year, mon, day, wkday;
  byte hur, min, sec;

  Wire.begin();           // I2Cマスタ初期化
  rtc.init();             // RTC初期化
  Serial.begin(19200);    // シリアル通信初期化

  Serial.println("RTC test");

  // 日時設定
  rtc.setDate(0x12, 4, 0x13, 5);  // 2012/4/13 金
  rtc.setTime(0x23, 0x59, 0x58);    //

  Serial.println("RTC set date/time");

  // 日時読み出し
  rtc.readDate(&year, &mon, &day, &wkday);
  rtc.readTime(&hur, &min, &sec);

  Serial.println("RTC read date/time");

  // 日時をシリアル送信
  sprintf(StrBuf, "20%02x/%02x/%02x-%02x", year, mon, day, wkday);
  Serial.println(StrBuf);
  sprintf(StrBuf, "%02x:%02x:%02x", hur, min, sec);
  Serial.println(StrBuf);

  // 10秒待ち
  delay(10000);

  // 日時を読み出し
  rtc.readDate(&year, &mon, &day, &wkday);
  rtc.readTime(&hur, &min, &sec);

  Serial.println("RTC read date/time");

  // 日時をシリアル送信
  sprintf(StrBuf, "20%02x/%02x/%02x-%02x", year, mon, day, wkday);
  Serial.println(StrBuf);
  sprintf(StrBuf, "%02x:%02x:%02x", hur, min, sec);
  Serial.println(StrBuf);

}


//
//  メインループ
//
void loop(void) {

}
