//
// 3つのI2C制御LCDを同時に使う場合のサンプルプログラム
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    12/05/10
//

#include <Wire.h>             // I2C
#include <wDisplay.h>   //

#define I2C_LCD_GENERAL  LCD_4BITMODE
#define I2C_LCD_ACM1602  LCD_8BITMODE
#define I2C_LCD_C51549   LCD_8BITMODE

// インスタンス生成
wI2cLcd lcd_acm(I2C_LCD_ACM1602);   // ACM1602
wI2cLcd lcd(I2C_LCD_GENERAL);       // 一般型
wI2cLcd lcd404(I2C_LCD_C51549);     // 40文字×4行タイプ


/*
  I2Cスレーブアドレス
    ACM1602 0x50
    I2C化LCD(一般型) 0x20
    I2C化LCD(40文字×4行型) 0x30

*/



char StrBuf[17];


void setup(void) {
  Wire.begin();       // I2C初期化

  lcd_acm.begin(16, 2, 0x50);
  lcd.begin(16, 2, 0x20);
  lcd404.begin(40, 4, 0x30);

  // 全クリア
  lcd_acm.clear();
  lcd.clear();
  lcd404.selectArea(2);     // 両エリア指定
  lcd404.clear();         // 全クリア

  // 文字列表示
  lcd_acm.print("ACM1602");
  lcd.print("S*1602");
  lcd404.selectArea(0);       // エリア0指定
  lcd404.print("C51549");
  lcd404.selectArea(1);       // エリア1指定
  lcd404.print("40x4");

  // カーソル位置指定
  lcd_acm.setCursor(5, 1);
  lcd.setCursor(5, 1);
  lcd404.setCursor(5, 1, 2);          // 両エリア

  // 文字列表示
  lcd_acm.print("TEST01");
  lcd.print("TEST02");
  lcd404.print("TEST03");

}

void loop(void) {
}

