//
//  I2CTestHost
//  7segLED テスト用I2C マスタ
//
//    copyright (c) 2012 T.Nakao
//    12/3/20
//

#include <Wire.h>

int I2CAdrs;
byte Buf[10];



// 初期化
void setup(void) {
  byte cmd, dat;
  byte i;

  pinMode(13, OUTPUT);        // オンボードLED
  I2CAdrs = 0x10;

  Buf[0] = 0x34;
  Buf[1] = 0x56;

  Wire.begin();       // マスタ初期化

  // 表示ON
  cmd = 0x82;
  dat = 0x01;
  Wire.beginTransmission(I2CAdrs);
  Wire.write(cmd);          // コマンド
  Wire.write(dat);
  Wire.endTransmission();


  // ゼロパディング
  cmd = 0x81;
  dat = 0x01;     // ゼロパディングあり
  Wire.beginTransmission(I2CAdrs);
  Wire.write(cmd);          // コマンド
  Wire.write(dat);
  Wire.endTransmission();


  // 固定値表示
  cmd = 123 >> 8;
  dat = 123;
  Wire.beginTransmission(I2CAdrs);
  Wire.write(cmd);          // コマンド
  Wire.write(dat);
  Wire.endTransmission();


  // ---------------------------------------

  delay(1000);


  // ゼロパディング
  cmd = 0x81;
  dat = 0x00;     // ゼロパディングなし
  Wire.beginTransmission(I2CAdrs);
  Wire.write(cmd);          // コマンド
  Wire.write(dat);
  Wire.endTransmission();


  // 固定値表示
  cmd = 567 >> 8;
  dat = 567;
  Wire.beginTransmission(I2CAdrs);
  Wire.write(cmd);          // コマンド
  Wire.write(dat);
  Wire.endTransmission();


  // ---------------------------------------

  delay(1000);


  // 少数点チェック
  cmd = 0x80;
  dat = 0x00;
  for(i = 0; i < 17; i++) {
    Wire.beginTransmission(I2CAdrs);
    Wire.write(cmd);          // コマンド
    Wire.write(dat);
    Wire.endTransmission();
    dat++;
    delay(500);
  }

  // ---------------------------------------


  for(i = 0; i < 5; i++) {

    // 表示OFF
    cmd = 0x82;
    dat = 0x00;
    Wire.beginTransmission(I2CAdrs);
    Wire.write(cmd);          // コマンド
    Wire.write(dat);
    Wire.endTransmission();

    delay(200);

    // 表示ON
    cmd = 0x82;
    dat = 0x01;
    Wire.beginTransmission(I2CAdrs);
    Wire.write(cmd);          // コマンド
    Wire.write(dat);
    Wire.endTransmission();

    delay(200);

  }

}

int Counter = 0;

// メインループ
void loop(void) {
  byte i;


  Buf[0] = (byte)(Counter >> 8);
  Buf[1] = (byte)(Counter & 0xFF);

  // マスタ送信
  Wire.beginTransmission(I2CAdrs);  // S.C発行,CB送信
  for(i = 0; i < 2; i++) {
    Wire.write(Buf[i]);             // データ書き込み
//    Wire.send(Buf[i]);            // データ書き込み(旧バージョン)
  }
  Wire.endTransmission();           // ストップ・コンディション

  digitalWrite(13, HIGH);   // LED ON

  Counter = (Counter + 1) % 10000;
  delay(50);
}
