//
//  40文字x4行LCD表示テスト
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//
//    固定値、カウンタ表示
//

#include <LiquidCrystal.h>
#include <stdio.h>

#define LCD_D0 2        // D2
#define LCD_D1 3        // D3
#define LCD_D2 4        // D4
#define LCD_D3 5        // D5
#define LCD_D4 6        // D6
#define LCD_D5 7        // D7
#define LCD_D6 8        // D8
#define LCD_D7 9        // D9

#define LCD_E  10       // D10

#define LCD_RS 12       // D12
//#define LCD_RW 12       // D12


// LCDのインスタンス化
LiquidCrystal lcd(LCD_RS, LCD_E, LCD_D0, LCD_D1, LCD_D2, LCD_D3,LCD_D4, LCD_D5, LCD_D6, LCD_D7);
//LiquidCrystal lcd(LCD_RS, LCD_RW, LCD_E, LCD_D0, LCD_D1, LCD_D2, LCD_D3,LCD_D4, LCD_D5, LCD_D6, LCD_D7);

char StrBuf[16];    // 文字列用配列
int Count = 0;    // カウント値

// 初期化
void setup(void) {
  lcd.begin(40, 2);    // LCDを16文字2列に設定
  lcd.setCursor(0, 0);    // 表示位置を指定

#ifdef DDD
  lcd.print("1234567890");
  lcd.print("1234567890");
  lcd.print("1234567890");
  lcd.print("1234567890");

  lcd.print("1234567890");
  lcd.print("1234567890");
  lcd.print("1234567890");
  lcd.print("1234567890");
#endif

  lcd.setCursor(0, 0);    // 表示位置を指定
  lcd.print("1234567890");

  lcd.setCursor(10, 1);    // 表示位置を指定
  lcd.print("1234567890");

  lcd.setCursor(20, 0);    // 表示位置を指定
  lcd.print("1234567890");

  lcd.setCursor(30, 1);    // 表示位置を指定
  lcd.print("1234567890");

}

void loop(void) {
  sprintf(StrBuf, "%04d", Count);
  lcd.setCursor(0, 1);          // 表示位置を指定
  lcd.print(StrBuf);            // LCDに文字列を表示
  Count = (Count + 1) %10000;   // カウント値更新
  delay(1000);                  // 1秒待つ
}
