//
//  #129 SPIテスト
//    copyright (c) 2013 T.Nakao      http://www.wsnak.com
//

#include <SPI.h>

/*
 DRDY: pin 6
 CSB: pin 7
 MOSI: pin 11
 MISO: pin 12
 SCK: pin 13
*/

#define SPI_CS_ON   digitalWrite(7, LOW)      // /cs = L
#define SPI_CS_OFF  digitalWrite(7, HIGH)     // /cs = H


void setup(void) {

  pinMode(7, OUTPUT);   // spi cs
  SPI.begin();

  SPI.setBitOrder(MSBFIRST);
  SPI.setDataMode(SPI_MODE1);

  delay(400);

  SPI_CS_ON;

  // 通信間にディレイ必要
  SpiSend(0x40+0);
  SpiSend(0x80+0);
  SpiSend(0x80+3);

  // 数値表示
  SpiSend(0x00+1);
  SpiSend(0x00+2);
  SpiSend(0x00+3);
  SpiSend(0x00+4);
  SpiSend(0x00+5);
  SpiSend(0x00+6);

    delay(1000);

    SpiSend(0x40+0);      // CP=0(左端)

    // マイナス表示
    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x00+0x20);   // マイナス表示
    delay(1000);

    SpiSend(0x40+0);      // CP=0(左端)

    // 数値表示
    SpiSend(0x00+7);
    SpiSend(0x00+8);
    SpiSend(0x00+9);
    SpiSend(0x00+0xA);
    SpiSend(0x00+0xB);
    SpiSend(0x00+0xC);

    delay(2000);

    SpiSend(0xA0+0x04+1);   // 数値点滅
    delay(2000);
    SpiSend(0xA0+1);      // 数値通常
    delay(2000);
    SpiSend(0xA0+0);      // 数値OFF
    delay(2000);
    SpiSend(0xA0+1);      // 数値通常
    delay(2000);
    SpiSend(0x80+0);      //
    delay(2000);
    SpiSend(0x80+1);      //
    delay(2000);
    SpiSend(0x80+2);      //
    delay(2000);

    SpiSend(0x80+0);
    delay(2000);

    SpiSend(0x40+5);    // CP=5(右端)
    delay(1000);

    // 数値表示(CP左移動)
    SpiSend(0x00+0x10+0xA);
    delay(500);
    SpiSend(0x00+0x10+0xB);
    delay(500);
    SpiSend(0x00+0x10+0xC);
    delay(500);
    SpiSend(0x00+0x10+0xD);
    delay(500);
    SpiSend(0x00+0x10+0xE);
    delay(500);
    SpiSend(0x00+0x10+0xF);
    delay(2000);

    SpiSend(0x80+0);    //
    SpiSend(0x40+0);    // CP=0(左端)
    delay(500);

    // 数値表示
    SpiSend(0x00+0xA);
    delay(500);
    SpiSend(0x00+0xB);
    delay(500);
    SpiSend(0x00+0xC);
    delay(500);
    SpiSend(0x00+0xD);
    delay(500);
    SpiSend(0x00+0xE);
    delay(500);
    SpiSend(0x00+0xF);

    delay(2000);

    // 小数点
    SpiSend(0x60+0x08+0);
    delay(500);
    SpiSend(0x60+0x08+1);
    delay(500);
    SpiSend(0x60+0x08+2);
    delay(500);
    SpiSend(0x60+0x08+3);
    delay(500);
    SpiSend(0x60+0x08+4);
    delay(500);
    SpiSend(0x60+0x08+5);
    delay(500);

    // 小数点(EX)
    SpiSend(0x60+0x10+0x08+0);
    delay(500);
    SpiSend(0x60+0x10+0x08+1);
    delay(500);
    SpiSend(0x60+0x10+0x08+2);
    delay(500);
    SpiSend(0x60+0x10+0x08+3);
    delay(500);
    SpiSend(0x60+0x10+0x08+4);
    delay(500);
    SpiSend(0x60+0x10+0x08+5);
    delay(500);
    SpiSend(0x60+0x00+5);

    // 小数点
    SpiSend(0x60+0x08+0);
    delay(500);
    SpiSend(0x60+0x08+1);
    delay(500);
    SpiSend(0x60+0x08+2);
    delay(500);
    SpiSend(0x60+0x08+3);
    delay(500);
    SpiSend(0x60+0x08+4);
    delay(500);
    SpiSend(0x60+0x08+5);
    delay(500);

    // 小数点
    SpiSend(0x60+0x08+5);
    delay(500);
    SpiSend(0x60+0x08+4);
    delay(500);
    SpiSend(0x60+0x08+3);
    delay(500);
    SpiSend(0x60+0x08+2);
    delay(500);
    SpiSend(0x60+0x08+1);
    delay(500);
    SpiSend(0x60+0x08+0);
    delay(500);

    SpiSend(0xA0+3);

    // 個別LED(ON)
    SpiSend(0xC0+0x08+0);
    delay(500);
    SpiSend(0xC0+0x08+1);
    delay(500);
    SpiSend(0xC0+0x08+2);
    delay(500);
    SpiSend(0xC0+0x08+3);
    delay(500);
    SpiSend(0xC0+0x08+4);
    delay(500);
    SpiSend(0xC0+0x08+5);
    delay(500);
    SpiSend(0xC0+0x08+6);
    delay(500);
    SpiSend(0xC0+0x08+7);
    delay(500);

    // 個別LED(OFF)
    SpiSend(0xC0+0x00+7);
    delay(500);
    SpiSend(0xC0+0x00+6);
    delay(500);
    SpiSend(0xC0+0x00+5);
    delay(500);
    SpiSend(0xC0+0x00+4);
    delay(500);
    SpiSend(0xC0+0x00+3);
    delay(500);
    SpiSend(0xC0+0x00+2);
    delay(500);
    SpiSend(0xC0+0x00+1);
    delay(500);
    SpiSend(0xC0+0x00+0);
    delay(500);

    // 個別LED(一部ブリンク)
    SpiSend(0xC0+0x08+0);
    delay(500);
    SpiSend(0xC0+0x08+1+0x10);    // ブリンク 1
    delay(500);
    SpiSend(0xC0+0x08+2);
    delay(500);
    SpiSend(0xC0+0x08+3);
    delay(500);
    SpiSend(0xC0+0x08+4+0x10);    // ブリンク 4
    delay(500);
    SpiSend(0xC0+0x08+5+0x10);    // ブリンク 5
    delay(500);
    SpiSend(0xC0+0x08+6);
    delay(500);
    SpiSend(0xC0+0x08+7+0x10);    // ブリンク 7
    delay(4000);

    SpiSend(0xC0+0x08+7);         // ブリンクストップ 7
    delay(1000);
    SpiSend(0xC0+0x08+5);         // ブリンクストップ 5
    delay(1000);
    SpiSend(0xC0+0x08+4);         // ブリンクストップ 4
    delay(1000);
    SpiSend(0xC0+0x08+1);         // ブリンクストップ 1

  SPI_CS_OFF;

}


void loop(void) {


}


void SpiSend(byte dat) {
  SPI.transfer(dat);
//  delay(1);
//  delayMicroseconds(500);   // OK
//  delayMicroseconds(100);   // OK
//  delayMicroseconds(10);    // NG
  delayMicroseconds(50);    // 50us OK
}
